// this is a very basic template. use it to start writing your own effects.
// if you want effects with lighting start from one of the GouraudXXXX or PhongXXXX effects

// --------------------------------------------------------------------------------------------------
// PARAMETERS:
// --------------------------------------------------------------------------------------------------

// -------------------------------------------------------------------------
// PARAMETERS:
// -------------------------------------------------------------------------

//transforms
float4x4 tW: WORLD; //the models world matrix
float4x4 tV: VIEW; //view matrix as set via Renderer (DX9)
float4x4 tP: PROJECTION; //projection matrix as set via Renderer (DX9)
float4x4 tWVP: WORLDVIEWPROJECTION;

//texture1
texture Tex <string uiname="LiveStream";>;
sampler Samp = sampler_state //sampler for doing the texture-lookup
{
   Texture   = (Tex);          //apply a texture to the sampler
   MipFilter = LINEAR;         //sampler states
   MinFilter = LINEAR;
   MagFilter = LINEAR;
};


//texture2
texture TexBack <string uiname="Background Image";>;
sampler Samp2 = sampler_state //sampler for doing the texture-lookup
{
   Texture   = (TexBack);         //apply a texture to the sampler
   MipFilter = LINEAR;         //sampler states
   MinFilter = LINEAR;
   MagFilter = LINEAR;
};

//texture3
texture Texkey <string uiname="Key Image";>;
sampler SampKey = sampler_state //sampler for doing the texture-lookup
{
   Texture   = (Texkey);         //apply a texture to the sampler
   MipFilter = LINEAR;         //sampler states
   MinFilter = LINEAR;
   MagFilter = LINEAR;
};


float thresh = 0.07;

//texture transformation marked with semantic TEXTUREMATRIX to achieve symmetric transformations
float4x4 tTex: TEXTUREMATRIX <string uiname="Texture Transform";>;

float4x4 tTexk: TEXTUREMATRIX <string uiname="Texture Transform Key";>;


struct vs2ps
{
   float4 Pos : POSITION;
   float4 TexCd : TEXCOORD0;
   float4 TexCdk : TEXCOORD1;
};
// -------------------------------------------------------------------------
// VERTEXSHADERS
// -------------------------------------------------------------------------

vs2ps VS(
   float4 Pos : POSITION,               // komma,komma,KlammerZU
   float4 TexCd : TEXCOORD0,
   float4 TexCdk : TEXCOORD1)
{
   //inititalize all fields of output struct with 0
   vs2ps Out = (vs2ps)0;

   //transform position
   Out.Pos = mul(Pos, tWVP);

   //transform texturecoordinates
   Out.TexCd = mul(TexCd, tTex);

 //transform texturecoordinates
   Out.TexCdk = mul(TexCd, tTexk);

   return Out;
}

// -------------------------------------------------------------------------
// PIXELSHADERS:
// -------------------------------------------------------------------------
float4 simpas(vs2ps In): COLOR
{
 float4 col = tex2D(Samp, In.TexCd);//float2(In.TexCd.x+(2.0/320.0),In.TexCd.y));
 return col;
}

float4 shobac(vs2ps In): COLOR
{
 float4 col = tex2D(Samp2, In.TexCd);//float2(In.TexCd.x+(2.0/320.0),In.TexCd.y));
 return col;
}

float4 shokey(vs2ps In): COLOR
{
 float4 col = tex2D(SampKey, In.TexCd);//float2(In.TexCd.x+(2.0/320.0),In.TexCd.y));
 return col;
}

float4 bacsub(vs2ps In): COLOR
{
 float4 key = tex2D(SampKey, In.TexCdk);
 float4 col = tex2D(Samp, In.TexCd);
 float4 col_back = tex2D(Samp2, In.TexCd);
 float4 tmp = distance(col_back , col);

 if (tmp.r>abs(thresh)) col.r=col.r; else  col.r= key.r;
 if (tmp.g>abs(thresh)) col.g=col.g; else  col.g= key.g;
 if (tmp.b>abs(thresh)) col.b=col.b; else  col.b= key.b;

 return col;
}

float4 foresub(vs2ps In): COLOR
{
 float4 key = tex2D(SampKey, In.TexCdk);
 float4 col = tex2D(Samp, In.TexCd);
 float4 col_back = tex2D(Samp2, In.TexCd);
 float4 tmp = distance(col_back , col);

 if (tmp.r<abs(thresh)) col.r=col.r; else  col.r= key.r;
 if (tmp.g<abs(thresh)) col.g=col.g; else  col.g= key.g;
 if (tmp.b<abs(thresh)) col.b=col.b; else  col.b= key.b;

 return col;
}




// -------------------------------------------------------------------------
// TECHNIQUES:
// -------------------------------------------------------------------------


technique showLiveStreamOnly //name for the technique pin
{
   pass P0
   {
       VertexShader = compile vs_1_1 VS();
       PixelShader  = compile ps_1_1 simpas();
   }
}

technique showBackgroundImageOnly //name for the technique pin
{
   pass P0
   {
       VertexShader = compile vs_1_1 VS();
       PixelShader  = compile ps_1_1 shobac();
   }
}

technique showKeyTextureOnly //name for the technique pin
{
   pass P0
   {
       VertexShader = compile vs_1_1 VS();
       PixelShader  = compile ps_1_1 shokey();
   }
}


technique BackgroundSubtraction //name for the technique pin
{
   pass P0
   {
       VertexShader = compile vs_1_1 VS();
       PixelShader  = compile ps_2_0 bacsub();
   }
}

technique ForegroundSubtraction //name for the technique pin
{
   pass P0
   {
       VertexShader = compile vs_1_1 VS();
       PixelShader  = compile ps_2_0 foresub();
   }
}



